using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace ComboBoxExample
{
    public partial class ComboBoxTest : Form
    {
        public ComboBoxTest()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DataTable cities = new DataTable();
            cities.Columns.Add("Name", typeof(string));

            for (int i=0; i < 5; i++)
            {
                DataRow rowCity = cities.NewRow();
                rowCity[0] = "City "+ i.ToString();
            }

            DataTable titles = new DataTable();
            titles.Columns.Add("TitleID", typeof(int));
            titles.Columns.Add("Title", typeof(string));
            
            DataRow rowMr = titles.NewRow();
            rowMr[0] = 0;
            rowMr[1] = "Mr";
            
            DataRow rowMs = titles.NewRow();
            rowMr[0] = 1;
            rowMr[1] = "Ms";

            DataTable parents = new DataTable();
            parents.Columns.Add("ID", typeof(int));
            parents.Columns.Add("Name", typeof(string));
            parents.Columns.Add("Title", typeof(string));
            parents.Columns.Add("City", typeof(string));

            DataTable children = parents.Clone();
            children.TableName = "Children";

            DataTable grandChildren = parents.Clone();
            grandChildren.TableName = "Grandchildren";

            for (int i = 0; i < 4; i++)
            {
                DataRow row = parents.NewRow();
                row["ID"] = i;
                row["Name"] = "Parent " + i.ToString();
                row["Title"] = i % 2;

                parents.Rows.Add(row);

                row = children.NewRow();
                row["ID"] = i;
                row["Name"] = "Child " + i.ToString();
                row["Title"] = i % 2;

                children.Rows.Add(row);

                row = grandChildren.NewRow();
                row["ID"] = i;
                row["Name"] = "Grandchild " + i.ToString();
                row["Title"] = i % 2;

                grandChildren.Rows.Add(row);
            }

            DataSet set = new DataSet();
            set.Tables.Add(parents);
            set.Tables.Add(children);
            set.Tables.Add(grandChildren);

            DataRelation relationPC = new DataRelation("ParentChildren", parents.Columns[0], children.Columns[0]);
            DataRelation relationCG = new DataRelation("ChildrenGrandchildren", children.Columns[0], grandChildren.Columns[0]);

            set.Relations.Add(relationCG);
            set.Relations.Add(relationPC);

            gridGroupingControl1.DataSource = parents;

            GridTableDescriptor parentsDesc = gridGroupingControl1.TableDescriptor;
            GridColumnDescriptor city = parentsDesc.Columns["City"];
            city.Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            city.Appearance.AnyRecordFieldCell.DataSource = cities;
            city.Appearance.AnyRecordFieldCell.ValueMember = "Name";
            city.Appearance.AnyRecordFieldCell.DisplayMember = "Name";

            GridColumnDescriptor title = parentsDesc.Columns["Title"];
            title.Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            title.Appearance.AnyRecordFieldCell.DataSource = titles;
            title.Appearance.AnyRecordFieldCell.DisplayMember = "TitleID";
            title.Appearance.AnyRecordFieldCell.ValueMember = "Title";

            GridTableDescriptor childDesc = gridGroupingControl1.GetTableDescriptor("Children");
            city = childDesc.Columns["City"];
            city.Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            city.Appearance.AnyRecordFieldCell.DataSource = cities;
            city.Appearance.AnyRecordFieldCell.ValueMember = "Name";
            city.Appearance.AnyRecordFieldCell.DisplayMember = "Name";
        }
    }
}